program project1;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}
  cthreads,
  {$ENDIF}
  Classes,
  DB,
  MemDS,
  sysutils,
  DateUtils,
  //mimepart, mimemess, smtpsend,    // Synapse; fürs eMail versenden
  DOM, XMLWrite;

var SQLRechnungsdruck, SQLFirma: TMemDataset;

procedure createTabellen;
begin
  SQLFirma := TMemDataset.Create(nil);
  SQLFirma.FieldDefs.Add('id',           ftInteger, 0);
  SQLFirma.FieldDefs.Add('Name',         ftString, 40);
  SQLFirma.FieldDefs.Add('Strasse',      ftString, 40);
  SQLFirma.FieldDefs.Add('Plz',          ftString,  5);
  SQLFirma.FieldDefs.Add('Ort',          ftString, 40);
  SQLFirma.FieldDefs.Add('LandKz',       ftString,  3);
  SQLFirma.FieldDefs.Add('eMail',        ftString, 40);
  SQLFirma.FieldDefs.Add('AP',           ftString, 40);
  SQLFirma.FieldDefs.Add('Telefon',      ftString, 15);
  SQLFirma.FieldDefs.Add('UStIdNr',      ftString, 12);
  SQLFirma.FieldDefs.Add('Bank',         ftString, 40);
  SQLFirma.FieldDefs.Add('Kontoinhaber', ftString, 40);
  SQLFirma.FieldDefs.Add('IBAN',         ftString, 22);
  SQLFirma.FieldDefs.Add('BIC',          ftString, 11);

  SQLFirma.Open;
  SQLFirma.Append;
  SQLFirma.FieldByName('id').AsInteger          := 1;
  SQLFirma.FieldByName('Name').AsString         := 'Programmierstube Bielefeld';
  SQLFirma.FieldByName('Strasse').AsString      := 'Blaise-Pascal-Weg 137c';
  SQLFirma.FieldByName('Plz').AsString          := '30301';
  SQLFirma.FieldByName('Ort').AsString          := 'Bielefeld';
  SQLFirma.FieldByName('LandKz').AsString       := 'DE';
  SQLFirma.FieldByName('eMail').AsString        := 'info@ps-Bielefeld.de';
  SQLFirma.FieldByName('AP').AsString           := 'Blaise Pascal';
  SQLFirma.FieldByName('Telefon').AsString      := '0521-12345-10';
  SQLFirma.FieldByName('UStIdNr').AsString      := 'DE123456789';
  SQLFirma.FieldByName('Bank').AsString         := 'Sparkasse BI';
  SQLFirma.FieldByName('Kontoinhaber').AsString := 'Blaise Pascal';
  SQLFirma.FieldByName('IBAN').AsString         := 'DE99123456781234567890';
  SQLFirma.FieldByName('BIC').AsString          := 'NODATA88';

  SQLRechnungsdruck := TMemDataset.Create(nil);
  SQLRechnungsdruck.FieldDefs.Add('id',           ftInteger); // Rechnung-ID
  SQLRechnungsdruck.FieldDefs.Add('Datum',        ftDate);
  SQLRechnungsdruck.FieldDefs.Add('DatumVon',     ftDate);
  SQLRechnungsdruck.FieldDefs.Add('DatumBis',     ftDate);
  SQLRechnungsdruck.FieldDefs.Add('Kundenid',     ftInteger);
  SQLRechnungsdruck.FieldDefs.Add('Name',         ftString,   40);
  SQLRechnungsdruck.FieldDefs.Add('Strasse',      ftString,   40);
  SQLRechnungsdruck.FieldDefs.Add('Plz',          ftString,    5);
  SQLRechnungsdruck.FieldDefs.Add('Ort',          ftString,   40);
  SQLRechnungsdruck.FieldDefs.Add('LandKz',       ftString,    3);
  SQLRechnungsdruck.FieldDefs.Add('UStIdNr',      ftString,   40);
  SQLRechnungsdruck.FieldDefs.Add('Leitweg',      ftString,   40);
  SQLRechnungsdruck.FieldDefs.Add('BestellNr',    ftString,   40);
  SQLRechnungsdruck.FieldDefs.Add('eMail',        ftString,   40);
  SQLRechnungsdruck.FieldDefs.Add('AP',           ftString,   40);
  SQLRechnungsdruck.FieldDefs.Add('Telefon',      ftString,   15);
  SQLRechnungsdruck.FieldDefs.Add('Zahlungsziel', ftInteger);
  // Daten aus Subtabelle Positionen
  SQLRechnungsdruck.FieldDefs.Add('Pos',          ftInteger);
  SQLRechnungsdruck.FieldDefs.Add('Menge',        ftCurrency, 10); // eigentlich: Typ Numeric
  SQLRechnungsdruck.FieldDefs.Add('ePreis',       ftCurrency, 10);
  SQLRechnungsdruck.FieldDefs.Add('MwStProz',     ftCurrency, 10); // eigentlich: Typ Numeric
  SQLRechnungsdruck.FieldDefs.Add('KurzBez',      ftString,   40);
  SQLRechnungsdruck.FieldDefs.Add('Bez',          ftString,  500);

  SQLRechnungsdruck.Open;
  SQLRechnungsdruck.Append;
  SQLRechnungsdruck.FieldByName('id').AsInteger           := 1;
  SQLRechnungsdruck.FieldByName('Datum').AsDateTime       := EnCodeDate(2024, 4, 1);
  SQLRechnungsdruck.FieldByName('DatumVon').AsDateTime    := EnCodeDate(2024, 3, 1);
  SQLRechnungsdruck.FieldByName('DatumBis').AsDateTime    := EnCodeDate(2024, 3, 31);
  SQLRechnungsdruck.FieldByName('Kundenid').AsInteger     := 1;
  SQLRechnungsdruck.FieldByName('Zahlungsziel').AsInteger := 14;
  SQLRechnungsdruck.FieldByName('Name').AsString          := 'Land Niedersachsen';
  SQLRechnungsdruck.FieldByName('Strasse').AsString       := 'Hohenzollernring 7a';
  SQLRechnungsdruck.FieldByName('Plz').AsString           := '49084';
  SQLRechnungsdruck.FieldByName('Ort').AsString           := 'Osnabrueck';
  SQLRechnungsdruck.FieldByName('LandKz').AsString        := 'DE';
  SQLRechnungsdruck.FieldByName('Leitweg').AsString       := '991-12345-88';
  SQLRechnungsdruck.FieldByName('BestellNr').AsString     := '0003459090';
  SQLRechnungsdruck.FieldByName('eMail').AsString         := 'info@blabla.de';
  SQLRechnungsdruck.FieldByName('AP').AsString            := 'Herr Meyer';
  SQLRechnungsdruck.FieldByName('Telefon').AsString       := '0541-123456';
  // Daten aus Subtabelle Positionen
  SQLRechnungsdruck.FieldByName('Pos').AsInteger          := 1;
  SQLRechnungsdruck.FieldByName('Menge').AsCurrency       := 17.5;
  SQLRechnungsdruck.FieldByName('ePreis').AsCurrency      := 119.00;
  SQLRechnungsdruck.FieldByName('MwStProz').AsCurrency    := 19.0;
  SQLRechnungsdruck.FieldByName('KurzBez').AsString       := 'Entwicklung';
  SQLRechnungsdruck.FieldByName('Bez').AsString           := 'Erstellung Pflichtenheft zur Erstellung einer XRechnung';
end;

function getMwSt(wert, MwStProz: Currency): Currency;
begin
  wert := wert * MwStProz;
  wert := trunc(wert + 0.5); // korrektes runden
  Result := wert / 100;
end;

function waehrung(wert: Double): String;
begin
  str(wert:0:2, Result);
end;

function punktZahl(s: String): String;
var i: integer;
begin
  i := pos(',', s);
  if i > 0 then
    s[i] := '.';
  Result := s;
end;

procedure createNode(xmlDoc: TXMLDocument; rootNode: TDOMNode; Element, text, AttrElement, AttrText: String);
var parentNode, textNode: TDOMNode;
begin
  parentNode := xmlDoc.CreateElement(Element);
  textNode := xmlDoc.CreateTextNode(text);
  parentNode.Appendchild(textNode);
  TDOMElement(parentNode).SetAttribute(AttrElement, AttrText);

  rootNode.Appendchild(parentNode);
end;

procedure createNode(xmlDoc: TXMLDocument; rootNode: TDOMNode; Element, text: String);
var parentNode, textNode: TDOMNode;
begin
  parentNode := xmlDoc.CreateElement(Element);
  textNode := xmlDoc.CreateTextNode(text);
  parentNode.Appendchild(textNode);

  rootNode.Appendchild(parentNode);
end;

procedure XMLExport;
var xmlDoc: TXMLDocument;
    rootNode, parentNode, subNode, sub2Node, sub3Node: TDOMNode;
    sumNetto, sumMwSt: Double;
    fileName: String;
    //MIMEText: TStrings;
    //MIMEPart: TMimePart;
    //MIMEMessage: TMimeMess;
    //FROM, TOEMAIL, TOkopie, TOCCKOPIE, Server, Passwort: String;
begin
  sumNetto := 0;
  sumMwSt := 0;
  SQLRechnungsdruck.First;
  fileName := 'Rechnung_' + SQLRechnungsdruck.FieldByName('id').AsString + '_' + SQLRechnungsdruck.FieldByName('Name').AsString + '.xml';
  while not SQLRechnungsdruck.Eof do
  begin
    sumNetto := sumNetto + SQLRechnungsdruck.FieldByName('Menge').AsFloat * SQLRechnungsdruck.FieldByName('ePreis').AsFloat;
    SQLRechnungsdruck.Next;
  end;
  { #todo : Achtung: bei wechselnden MwSt-Sätzen muß hier umgerechnet werden! }
  sumMwSt := getMwSt(sumNetto, SQLRechnungsdruck.FieldByName('MwStProz').AsFloat);

  // XRechnung Spezifikation:
  // https://xeinkauf.de/xrechnung/
  xmlDoc := TXMLDocument.Create;

  // Header
  rootNode := xmlDoc.CreateElement('ns0:Invoice');
  TDOMElement(rootNode).SetAttribute('xmlns:ns0', 'urn:oasis:names:specification:ubl:schema:xsd:Invoice-2');
  TDOMElement(rootNode).SetAttribute('xmlns:cac', 'urn:oasis:names:specification:ubl:schema:xsd:CommonAggregateComponents-2');
  TDOMElement(rootNode).SetAttribute('xmlns:cbc', 'urn:oasis:names:specification:ubl:schema:xsd:CommonBasicComponents-2');
  TDOMElement(rootNode).SetAttribute('xmlns:cec', 'urn:oasis:names:specification:ubl:schema:xsd:CommonExtensionComponents-2');
  xmlDoc.Appendchild(RootNode);
  createNode(xmlDoc, rootNode, 'cbc:CustomizationID', 'urn:cen.eu:en16931:2017#compliant#urn:xoev-de:kosit:standard:xrechnung_2.2');

  // Rechnungsdaten
  parentNode := xmlDoc.CreateComment(' Rechnungsdaten ');
  rootNode.Appendchild(parentNode);
  createNode(xmlDoc, rootNode, 'cbc:ID', SQLRechnungsdruck.FieldByName('id').AsString);
  createNode(xmlDoc, rootNode, 'cbc:IssueDate', FormatDateTime('yyyy-mm-dd', SQLRechnungsdruck.FieldByName('Datum').AsDateTime));
  createNode(xmlDoc, rootNode, 'cbc:DueDate', FormatDateTime('yyyy-mm-dd', SQLRechnungsdruck.FieldByName('Datum').AsDateTime + SQLRechnungsdruck.FieldByName('Zahlungsziel').AsInteger));
  createNode(xmlDoc, rootNode, 'cbc:InvoiceTypeCode', '380');  // 380: Commercial invoice
  createNode(xmlDoc, rootNode, 'cbc:DocumentCurrencyCode', 'EUR');
  createNode(xmlDoc, rootNode, 'cbc:BuyerReference', SQLRechnungsdruck.FieldByName('Leitweg').AsString);
  parentNode := xmlDoc.CreateElement('cac:InvoicePeriod');
    createNode(xmlDoc, parentNode, 'cbc:StartDate', FormatDateTime('yyyy-mm-dd', SQLRechnungsdruck.FieldByName('DatumVon').AsDateTime));
    createNode(xmlDoc, parentNode, 'cbc:EndDate', FormatDateTime('yyyy-mm-dd', SQLRechnungsdruck.FieldByName('DatumBis').AsDateTime));
  rootNode.Appendchild(parentNode);
  parentNode := xmlDoc.CreateElement('cac:OrderReference');
    createNode(xmlDoc, parentNode, 'cbc:ID', SQLRechnungsdruck.FieldByName('BestellNr').AsString);
  rootNode.Appendchild(parentNode);

  // Firmendaten
  parentNode := xmlDoc.CreateComment(' Firmendaten ');
  rootNode.Appendchild(parentNode);
  parentNode := xmlDoc.CreateElement('cac:AccountingSupplierParty');
    subNode := xmlDoc.CreateElement('cac:Party');
      sub2Node := xmlDoc.CreateElement('cac:PostalAddress');
        createNode(xmlDoc, sub2Node, 'cbc:StreetName', SQLFirma.FieldByName('Strasse').AsString);
        createNode(xmlDoc, sub2Node, 'cbc:CityName', SQLFirma.FieldByName('Ort').AsString);
        createNode(xmlDoc, sub2Node, 'cbc:PostalZone', SQLFirma.FieldByName('Plz').AsString);
        sub3Node := xmlDoc.CreateElement('cac:Country');
          createNode(xmlDoc, sub3Node, 'cbc:IdentificationCode', SQLFirma.FieldByName('LandKz').AsString);
        sub2Node.Appendchild(sub3Node);
      subNode.Appendchild(sub2Node);
      sub2Node := xmlDoc.CreateElement('cac:PartyTaxScheme');
        createNode(xmlDoc, sub2Node, 'cbc:CompanyID', SQLFirma.FieldByName('UStIDNr').AsString);
        sub3Node := xmlDoc.CreateElement('cac:TaxScheme');
          createNode(xmlDoc, sub3Node, 'cbc:ID', 'VAT');
        sub2Node.Appendchild(sub3Node);
      subNode.Appendchild(sub2Node);
      sub2Node := xmlDoc.CreateElement('cac:PartyLegalEntity');
        createNode(xmlDoc, sub2Node, 'cbc:RegistrationName', SQLFirma.FieldByName('Name').AsString);
      subNode.Appendchild(sub2Node);
      sub2Node := xmlDoc.CreateElement('cac:Contact');
      createNode(xmlDoc, sub2Node, 'cbc:Name', SQLFirma.FieldByName('AP').AsString);
      createNode(xmlDoc, sub2Node, 'cbc:Telephone', SQLFirma.FieldByName('Telefon').AsString);
      createNode(xmlDoc, sub2Node, 'cbc:ElectronicMail', SQLFirma.FieldByName('eMail').AsString);
      subNode.Appendchild(sub2Node);
    parentNode.Appendchild(subNode);
  rootNode.Appendchild(parentNode);

  // Kundendaten
  parentNode := xmlDoc.CreateComment(' Kundendaten ');
  rootNode.Appendchild(parentNode);
  parentNode := xmlDoc.CreateElement('cac:AccountingCustomerParty');
    subNode := xmlDoc.CreateElement('cac:Party');
      sub2Node := xmlDoc.CreateElement('cac:PartyIdentification');
        createNode(xmlDoc, sub2Node, 'cbc:ID', SQLRechnungsdruck.FieldByName('KundenID').AsString);
      subNode.Appendchild(sub2Node);
      sub2Node := xmlDoc.CreateElement('cac:PostalAddress');
        createNode(xmlDoc, sub2Node, 'cbc:StreetName', SQLRechnungsdruck.FieldByName('Strasse').AsString);
        createNode(xmlDoc, sub2Node, 'cbc:CityName', SQLRechnungsdruck.FieldByName('Ort').AsString);
        createNode(xmlDoc, sub2Node, 'cbc:PostalZone', SQLRechnungsdruck.FieldByName('Plz').AsString);
        sub3Node := xmlDoc.CreateElement('cac:Country');
          createNode(xmlDoc, sub3Node, 'cbc:IdentificationCode', 'DE'); //SQLRechnungsdruck.FieldByName('LandKz').AsString); // muß DE sein; raus, da fehleranfällig
        sub2Node.Appendchild(sub3Node);
      subNode.Appendchild(sub2Node);
      sub2Node := xmlDoc.CreateElement('cac:PartyLegalEntity');
        createNode(xmlDoc, sub2Node, 'cbc:RegistrationName', SQLRechnungsdruck.FieldByName('Name').AsString);
      subNode.Appendchild(sub2Node);
    parentNode.Appendchild(subNode);
  rootNode.Appendchild(parentNode);

  // Kontodaten
  parentNode := xmlDoc.CreateComment(' Kontodaten ');
  rootNode.Appendchild(parentNode);
  parentNode := xmlDoc.CreateElement('cac:PaymentMeans');
    createNode(xmlDoc, parentNode, 'cbc:PaymentMeansCode', '58'); // Code 58: nur die IBAN wird benötigt
    subNode := xmlDoc.CreateElement('cac:PayeeFinancialAccount');
      createNode(xmlDoc, subNode, 'cbc:ID', SQLFirma.FieldByName('IBAN').AsString);
      createNode(xmlDoc, subNode, 'cbc:Name', SQLFirma.FieldByName('KontoInhaber').AsString);
      sub2Node := xmlDoc.CreateElement('cac:FinancialInstitutionBranch');
        createNode(xmlDoc, sub2Node, 'cbc:ID', SQLFirma.FieldByName('BIC').AsString);
      subNode.Appendchild(sub2Node);
    parentNode.Appendchild(subNode);
  rootNode.Appendchild(parentNode);

  // Umsatzsteuerdaten
  parentNode := xmlDoc.CreateComment(' Umsatzsteuerdaten ');
  rootNode.Appendchild(parentNode);
  parentNode := xmlDoc.CreateElement('cac:TaxTotal');
    createNode(xmlDoc, parentNode, 'cbc:TaxAmount', waehrung(sumMwSt), 'currencyID', 'EUR');
    subNode := xmlDoc.CreateElement('cac:TaxSubtotal');
      createNode(xmlDoc, subNode, 'cbc:TaxableAmount', waehrung(sumNetto), 'currencyID', 'EUR');
      createNode(xmlDoc, subNode, 'cbc:TaxAmount', waehrung(sumMwSt), 'currencyID', 'EUR');
        sub2Node := xmlDoc.CreateElement('cac:TaxCategory');
        createNode(xmlDoc, sub2Node, 'cbc:ID', 'S');
        createNode(xmlDoc, sub2Node, 'cbc:Percent', SQLRechnungsdruck.FieldByName('MwStProz').AsString);
        sub3Node := xmlDoc.CreateElement('cac:TaxScheme');
          createNode(xmlDoc, sub3Node, 'cbc:ID', 'VAT');
        sub2Node.Appendchild(sub3Node);
      subNode.Appendchild(sub2Node);
    parentNode.Appendchild(subNode);
  rootNode.Appendchild(parentNode);

  // Zahlungsdaten
  parentNode := xmlDoc.CreateComment(' Zahlungsdaten ');
  rootNode.Appendchild(parentNode);
  parentNode := xmlDoc.CreateElement('cac:LegalMonetaryTotal');
    createNode(xmlDoc, parentNode, 'cbc:LineExtensionAmount', waehrung(sumNetto), 'currencyID', 'EUR');
    createNode(xmlDoc, parentNode, 'cbc:TaxExclusiveAmount', waehrung(sumNetto), 'currencyID', 'EUR');
    createNode(xmlDoc, parentNode, 'cbc:TaxInclusiveAmount', waehrung(sumNetto + sumMwSt), 'currencyID', 'EUR');   // Summe Brutto
    createNode(xmlDoc, parentNode, 'cbc:PayableAmount', waehrung(sumNetto + sumMwSt), 'currencyID', 'EUR');
  rootNode.Appendchild(parentNode);

  // Rechnungspositionen
  parentNode := xmlDoc.CreateComment(' Rechnungspositionen ');
  rootNode.Appendchild(parentNode);
  SQLRechnungsdruck.First;
  while not SQLRechnungsdruck.Eof do
  begin
    parentNode := xmlDoc.CreateElement('cac:InvoiceLine');
      createNode(xmlDoc, parentNode, 'cbc:ID', SQLRechnungsdruck.FieldByName('Pos').AsString);
      createNode(xmlDoc, parentNode, 'cbc:InvoicedQuantity', punktZahl(SQLRechnungsdruck.FieldByName('Menge').AsString), 'unitCode', 'C62');
      createNode(xmlDoc, parentNode, 'cbc:LineExtensionAmount', waehrung(sumNetto), 'currencyID', 'EUR');
      subNode := xmlDoc.CreateElement('cac:Item');
        createNode(xmlDoc, subNode, 'cbc:Description', SQLRechnungsdruck.FieldByName('Bez').AsString);
        createNode(xmlDoc, subNode, 'cbc:Name', SQLRechnungsdruck.FieldByName('KurzBez').AsString);
        sub2Node := xmlDoc.CreateElement('cac:ClassifiedTaxCategory');
          createNode(xmlDoc, sub2Node, 'cbc:ID', 'S');
          createNode(xmlDoc, sub2Node, 'cbc:Percent', punktZahl(SQLRechnungsdruck.FieldByName('MwStProz').AsString));
          sub3Node := xmlDoc.CreateElement('cac:TaxScheme');
            createNode(xmlDoc, sub3Node, 'cbc:ID', 'VAT');
          sub2Node.Appendchild(sub3Node);
        subNode.Appendchild(sub2Node);
      parentNode.Appendchild(subNode);
      subNode := xmlDoc.CreateElement('cac:Price');
        createNode(xmlDoc, subNode, 'cbc:PriceAmount', waehrung(SQLRechnungsdruck.FieldByName('ePreis').AsFloat), 'currencyID', 'EUR');
      parentNode.Appendchild(subNode);
    rootNode.Appendchild(parentNode);

    SQLRechnungsdruck.Next;
  end;

  writeXMLFile(xmlDoc, fileName);

  // Test per eMail versenden an ref.xrechnung@portal.bund.de
  // muß dann auf xrechnung@portal.bund.de geändert werden

  //MIMEText := TStringList.Create;
  //MIMEText.Add('XRechnung im Anhang...');
  //
  //MIMEMessage := TMimeMess.Create;
  //with MIMEMessage do
  //try
  //  FROM := 'info@ps-bielefeld.de';
  //  TOEMAIL := 'ref.xrechnung@portal.bund.de';
  //  TOKOPIE := 'blaise.pascal@ps-bielefeld.de';
  //  //TOCCKOPIE := '';
  //  SERVER := 'v000003.kasserver.com:25';
  //  PASSWORT := 'GanzGeheim';
  //
  //  Header.Date := Now;
  //  Header.From := FROM;
  //  Header.ToList.Clear;
  //  Header.ToList.Add(TOEMAIL);
  //  Header.ToList.Add(TOKOPIE);
  //  Header.CcList.Clear;
  //  Header.Subject := 'XRechnung';
  //  Header.XMailer := 'GeVerSyS';
  //
  //  MIMEPart := AddPartMultipart('mixed', nil);
  //
  //  AddPartText(MIMEText, MIMEPart);
  //  AddPartBinaryFromFile(fileName, MIMEPart);
  //  EncodeMessage;
  //
  //  if SendToRaw(Header.From,
  //               Header.ToList.CommaText,
  //               SERVER,
  //               Lines,
  //               FROM,
  //               PASSWORT)
  //  then
  //    ShowMessage('eMail versendet.')
  //  else
  //    ShowMessage('eMail nicht versendet');
  //finally
  //  Free;
  //  MIMEText.Free;
  //end;
end;

begin
  createTabellen;
  XMLExport;
end.

